package
 {
  import flash.utils.Timer;
  import flash.events.TimerEvent;
  import flash.events.ProgressEvent;
  import flash.events.MouseEvent;
  import flash.net.URLRequest;
  import flash.net.navigateToURL;
  import flash.display.Sprite;

  public class AR_winImage extends AR_Window
   {
    private var tool_bar : Sprite;
    private var url      : String;
    private var current  : int;
    private var timer    : Timer;
    private var first    : AR_Button;
	private var prev     : AR_Button;
	private var auto     : AR_Button;
	private var stop     : AR_Button;
	private var next     : AR_Button;
	private var last     : AR_Button;
	private var enlarge  : AR_Button;

	public var image    : AR_Image;
	public var progress : AR_Loader;

    public function AR_winImage(dsk : AR_Desktop, skn : XML, tit : String, w : int, h : int)
     {
	  var total_buttons : int;
	  var button_height : int;
	  var button_width  : int;

      super(dsk,skn,tit,w,h);

      current = 0;
      timer  = new Timer(desktop.getConfig().slideshow_time*1000);
      timer.addEventListener(TimerEvent.TIMER, slideshow);

      image = new AR_Image("",w,h);
      image.x = body_left_margin;
      image.y = body_top_margin;
      body.addChild(image);

      image.loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, eventProgress);
      if(desktop.getConfig().enlarge_on == 1) image.addEventListener(MouseEvent.CLICK, clickEnlarge);

      progress = new AR_Loader();
      progress.x = (w  - progress.width) / 2;
      progress.y = (h - progress.height) / 2;

      if(desktop.getConfig().toolbar_on == 1)
       {
        tool_bar = new Sprite();
        //TODO aggiustare icone pulsanti...
        if(desktop.getConfig().enlarge_on == 1) total_buttons = 6; else total_buttons = 5;
        button_width  = skin.toolbar_button_width;
        button_height = skin.toolbar_button_height;
        first   = new AR_Button(desktop,new XML(skin),'',skin.button_first_icon,  button_width,button_height);
	    prev    = new AR_Button(desktop,new XML(skin),'',skin.button_prev_icon,   button_width,button_height);
	    auto    = new AR_Button(desktop,new XML(skin),'',skin.button_auto_icon,   button_width,button_height);
	    stop    = new AR_Button(desktop,new XML(skin),'',skin.button_stop_icon,   button_width,button_height);
	    next    = new AR_Button(desktop,new XML(skin),'',skin.button_next_icon,   button_width,button_height);
	    last    = new AR_Button(desktop,new XML(skin),'',skin.button_last_icon,   button_width,button_height);
	    if(desktop.getConfig().enlarge_on == 1) enlarge = new AR_Button(desktop,new XML(skin),'',skin.button_enlarge_icon,button_width,button_height);
	    first.addEventListener(MouseEvent.CLICK, clickFirst);
	    prev.addEventListener (MouseEvent.CLICK, clickPrev);
        auto.addEventListener (MouseEvent.CLICK, clickAuto);
        stop.addEventListener (MouseEvent.CLICK, clickStop);
	    next.addEventListener (MouseEvent.CLICK, clickNext);
	    last.addEventListener (MouseEvent.CLICK, clickLast);
	    if(desktop.getConfig().enlarge_on == 1) enlarge.addEventListener(MouseEvent.CLICK, clickEnlarge);
	    first.x   = 0 * button_width; first.y   = 0;
	    prev.x    = 1 * button_width; prev.y    = 0;
	    auto.x    = 2 * button_width; auto.y    = 0;
	    stop.x    = 2 * button_width; stop.y    = 0; stop.visible = false;
	    next.x    = 3 * button_width; next.y    = 0;
	    last.x    = 4 * button_width; last.y    = 0;
	    if(desktop.getConfig().enlarge_on == 1) { enlarge.x = 5 * button_width; enlarge.y = 0; }
	    tool_bar.addChild(first);
	    tool_bar.addChild(prev);
	    tool_bar.addChild(auto);
	    tool_bar.addChild(stop);
	    tool_bar.addChild(next);
	    tool_bar.addChild(last);
	    if(desktop.getConfig().enlarge_on == 1) tool_bar.addChild(enlarge);
	    tool_bar.alpha = skin.toolbar_alpha;
	    tool_bar.addEventListener(MouseEvent.ROLL_OVER, enterToolbar);
	    tool_bar.addEventListener(MouseEvent.ROLL_OUT, exitToolbar);

	    tool_bar.x = skin.toolbar_x_position;
	    if(skin.toolbar_x_position == 'left')   tool_bar.x = skin.window_body_left_margin;
	    if(skin.toolbar_x_position == 'center') tool_bar.x = (w >> 1) - (button_width * total_buttons >> 1) + (int)(skin.window_body_left_margin);
	    if(skin.toolbar_x_position == 'right')  tool_bar.x = w - button_width * total_buttons + (int)(skin.window_body_left_margin);

	    tool_bar.y = skin.toolbar_y_position;
	    if(skin.toolbar_y_position == 'top')    tool_bar.y = skin.window_body_top_margin;
	    if(skin.toolbar_y_position == 'center') tool_bar.y = (h >> 1) - (button_height >> 1) + (int)(skin.window_body_top_margin);
	    if(skin.toolbar_y_position == 'bottom') tool_bar.y = h - button_height + (int)(skin.window_body_top_margin);

	    body.addChild(tool_bar);
	   }
     }

    public function loadImage() : void
     {
	  url = desktop.thumbs.getThumb(current).getLink();
	  progress.resetLoader();
	  image.loadImage(url);
	  addChild(progress);
	  //setTitle("");// TODO image name...
	  setUrl(url);
	 }

    private function clickFirst(event : MouseEvent) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
	  if(current != 0) { current = 0; loadImage(); }
     }

    private function clickPrev(event : MouseEvent) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
	  if(current > 0) { current --; loadImage(); }
     }

    private function clickAuto(event : MouseEvent) : void
     {
	  stop.visible = true;
	  auto.visible = false;
	  timer.start();
	 }

    private function clickStop(event : MouseEvent) : void
     {
	  stop.visible = false;
	  auto.visible = true;
	  timer.reset();
	 }

    private function clickNext(event : MouseEvent) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
      if(current < desktop.thumbs.getTotalThumbs() - 1) { current ++; loadImage(); }
     }

    private function clickLast(event : MouseEvent) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
	  if(current != desktop.thumbs.getTotalThumbs() - 1) { current = desktop.thumbs.getTotalThumbs() - 1; loadImage(); }
     }

    private function clickEnlarge(event : MouseEvent) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
      var url : URLRequest = new URLRequest(this.url);
      navigateToURL(url,"_albume_show");
     }

    private function slideshow(event : TimerEvent) : void
     {
	  current ++;
      if(current > desktop.thumbs.getTotalThumbs() - 1) current = 0;
      loadImage();
     }

    private function eventProgress(event : ProgressEvent) : void
     {
	  var p : int = (int)(event.bytesLoaded / event.bytesTotal * 100);
      progress.setPercentage(p);
      if(p >= 100) removeChild(progress);
     }

    private function enterToolbar(event : MouseEvent) : void
     {
	  tool_bar.alpha = 1.0;
     }

    private function exitToolbar(event : MouseEvent) : void
     {
	  tool_bar.alpha = skin.toolbar_alpha;
     }

    public function setUrl(url : String) : void
     {
	  this.url = url;
	 }

    public function setCurrent(i : int) : void
     {
	  if(timer.running)
	   {
	    stop.visible = false;
	    auto.visible = true;
	    timer.reset();
	   }
	  current = i;
	 }
   }
 }
