package
 {
  import flash.utils.Timer;
  import flash.events.TimerEvent;
  import flash.events.MouseEvent;

  public class AR_winImagesList extends AR_Window
   {
	private var target         : AR_winImage;
	private var margin         : int;
	private var spacing        : int;
	private var position       : int;
	private var visible_thumbs : int;
	private var thumb_width    : int;
	private var thumb_height   : int;
    private var layout         : int;
    private var shadow         : int;
	private var _THUMBS        : Array = new Array();
	private var _SHADOWS       : Array = new Array();
	private var up             : AR_Button;
	private var down           : AR_Button;
	private var scroll         : int;
	private var scroll_speed   : int;
	private var offset         : int;
	private var delta          : int;
    private var timer          : Timer;	

    public function AR_winImagesList(dsk : AR_Desktop, skn : XML, tit : String, trg : AR_winImage, t_w : int, t_h : int, t_n : int)
     {
	  var w : int;
	  var h : int;

      thumb_width    = t_w;
      thumb_height   = t_h;
	  visible_thumbs = t_n;
      margin         = skn.margin;
      spacing        = skn.spacing;
      shadow         = skn.shadow;
      if(skn.window_layout == "horizontal") layout = 1;
      else                                  layout = 0;
      if(layout) // Horizontal layout
       {
		w = visible_thumbs * (thumb_width + spacing) + 2 * margin - spacing;
		h = thumb_height;
		if(shadow) h += thumb_height >> shadow;
	   }
      else
       {shadow = 0; //TODO aggiustare bug ombre in layout verticale (per ora sono disattive)
	    w = thumb_width;
	    h = visible_thumbs * (thumb_height + spacing) + 2 * margin - spacing;
	    if(shadow) h += visible_thumbs * (thumb_height >> shadow);
	   }
	  super(dsk,skn,tit,w,h);

      delta  = 0;
      offset = 0;
      scroll       = skin.scroll;
      scroll_speed = skin.scroll_speed;
      timer  = new Timer(10);
      timer.addEventListener(TimerEvent.TIMER, moveThumb);
      skin.up_icon   = skn.up_icon;
      skin.down_icon = skn.down_icon;
	  position       = 0;
	  if(layout) margin += body_left_margin;
	  else       margin += body_top_margin;
	  target         = trg;

	  // Up button
	  if(layout) // Horizontal layout
	   {
	    up = new AR_Button(desktop,new XML(skin),skin.button_up_label,skin.button_up_icon,20,thumb_height,2);
	    up.x = body_left_margin; up.y = body_top_margin;
	   }
	  else
	   {
	    up = new AR_Button(desktop,new XML(skin),skin.button_up_label,skin.button_up_icon,thumb_width,20,2);
	    up.x = body_left_margin; up.y = body_top_margin;
	   }
	  up.addEventListener(MouseEvent.CLICK, clickUp);
	  body.addChild(up);

	  // Down button
	  if(layout) // Horizontal layout
	   {
	    down = new AR_Button(desktop,new XML(skin),skin.button_down_label,skin.button_down_icon,20,thumb_height,3);
	    down.x = w + body_left_margin - 20 ; down.y = body_top_margin;
	   }
	  else
	   {
	    down = new AR_Button(desktop,new XML(skin),skin.button_down_label,skin.button_down_icon,thumb_width,20,3);
	    down.x = body_left_margin; down.y = h + body_top_margin - 20;
	   }
	  down.addEventListener(MouseEvent.CLICK, clickDown);
	  body.addChild(down);
     }

    public function addThumb(url : String, link : String) : void
	 {
      var l : int;
      
      timer.start();
      if(shadow)
       {
        l = _SHADOWS.push(new AR_Thumbnail(url,link,target,thumb_width,thumb_height));
        _SHADOWS[l-1].alpha = 0.5;
        body.addChild(_SHADOWS[l-1]);
	   }
      l = _THUMBS.push(new AR_Thumbnail(url,link,target,thumb_width,thumb_height));
      _THUMBS[l-1].setIndex(l-1);
      body.addChild(_THUMBS[l-1]);
	 }

    public function clearThumbs() : void
	 {
      var i : int;
      var l : int = _THUMBS.length;

      for(i = 0; i < l; i++)
       {
	    body.removeChild(_THUMBS[i]);
	    if(shadow) body.removeChild(_SHADOWS[i]);
       }
      _THUMBS = new Array();
      if(shadow) _SHADOWS = new Array();
      position = 0;
	 }

    public function drawThumbs() : void
	 {
	  var i   : int;
	  var n   : int;

      if(_THUMBS.length + position < visible_thumbs) n = _THUMBS.length + position;
      else                                           n = visible_thumbs + position;

      for(i = 0; i < _THUMBS.length; i++)
       {	    
	    _THUMBS[i].visible = false;
	    _THUMBS[i].alpha   = 1;
	    _THUMBS[i].width   = thumb_width;
	    _THUMBS[i].height  = thumb_height;
	    if(layout)  // Horizontal layout
	     {
	      _THUMBS[i].x = (i - position) * (thumb_width + spacing) + margin + offset;
	      _THUMBS[i].y = body_top_margin;
	     }
        else
         {
          _THUMBS[i].x = body_left_margin;
	      _THUMBS[i].y = (i - position) * (thumb_height + spacing) + margin + offset;
	     }
	    if(shadow)
	     {
          _SHADOWS[i].visible = false;
	      _SHADOWS[i].width   = thumb_width;
          _SHADOWS[i].height  = thumb_height >> shadow;
          if(_SHADOWS[i].scaleY > 0) _SHADOWS[i].scaleY = -_SHADOWS[i].scaleY;
          _SHADOWS[i].x = _THUMBS[i].x;
          _SHADOWS[i].y = body_top_margin + thumb_height + (thumb_height >> shadow);
		 }

	    if(i >= position && i <= n-1)
	     {
		  _THUMBS[i].visible = true;
		  if(shadow) _SHADOWS[i].visible = true;
	     }

	    if(i == position - 1 && delta > 0)
	     {
		  _THUMBS[i].visible = true;
	      if(layout)
	       {
			_THUMBS[i].alpha  = offset/(thumb_width + spacing);
	        _THUMBS[i].width  = offset * thumb_width / (thumb_width + spacing);
	        _THUMBS[i].x      = margin;
		   }
	      else
	       {
			_THUMBS[i].alpha  = offset/(thumb_height + spacing);
			_THUMBS[i].height = offset * thumb_height / (thumb_height + spacing);
			_THUMBS[i].y      = margin;
		   }
	      if(shadow)
           {
            _SHADOWS[i].visible = true;
            _SHADOWS[i].alpha   = _THUMBS[i].alpha / 2;
	        _SHADOWS[i].width   = _THUMBS[i].width;
            _SHADOWS[i].x       = _THUMBS[i].x;
            if(_SHADOWS[i].scaleY > 0) _SHADOWS[i].scaleY = -_SHADOWS[i].scaleY;
		   }
	     }

	    if(i == position     && delta < 0)
	     {
		  _THUMBS[i].visible = true;
	      if(layout)
	       {
			_THUMBS[i].alpha  = 1 + offset/(thumb_width + spacing);
	        _THUMBS[i].width  = thumb_width + offset * thumb_width / (thumb_width + spacing);
	        _THUMBS[i].x      = margin;
	       }
	      else
	       {
			_THUMBS[i].alpha  = 1 + offset/(thumb_height + spacing);
			_THUMBS[i].height = thumb_height + offset * thumb_height / (thumb_height + spacing);
			_THUMBS[i].y      = margin;
		   }
	      if(shadow)
           {
            _SHADOWS[i].visible = true;
            _SHADOWS[i].alpha   = _THUMBS[i].alpha / 2;
	        _SHADOWS[i].width   = _THUMBS[i].width;
            _SHADOWS[i].x       = _THUMBS[i].x;
            if(_SHADOWS[i].scaleY > 0) _SHADOWS[i].scaleY = -_SHADOWS[i].scaleY;
		   }
	     }

	    if(i == n - 1        && delta > 0)
	     {
		  _THUMBS[i].visible = true;
		  if(layout)
		   {
	        _THUMBS[i].alpha  = 1 - offset/(thumb_width + spacing);
	        _THUMBS[i].width  = thumb_width - offset * thumb_width / (thumb_width + spacing);// TODO risolvere bug
		   }
		  else
		   {
	        _THUMBS[i].alpha  = 1 - offset/(thumb_height + spacing);
	        _THUMBS[i].height = thumb_height - offset * thumb_height / (thumb_height + spacing);// TODO risolvere bug
		   }
	      if(shadow)
           {
            _SHADOWS[i].visible = true;
            _SHADOWS[i].alpha   = _THUMBS[i].alpha / 2;
	        _SHADOWS[i].width   = _THUMBS[i].width;
            _SHADOWS[i].x       = _THUMBS[i].x;
            if(_SHADOWS[i].scaleY > 0) _SHADOWS[i].scaleY = -_SHADOWS[i].scaleY;
		   }
	     }

	    if(i == n            && delta < 0)
	     {
		  _THUMBS[i].visible = true;
		  if(layout)
		   {
	        _THUMBS[i].alpha  = - offset/(thumb_width + spacing);
	        _THUMBS[i].width  = - offset * thumb_width / (thumb_width + spacing);// TODO risolvere bug
		   }
		  else
		   {
	        _THUMBS[i].alpha  = - offset/(thumb_height + spacing);
	        _THUMBS[i].height = - offset * thumb_height / (thumb_height + spacing);// TODO risolvere bug
		   }
	      if(shadow)
           {
            _SHADOWS[i].visible = true;
            _SHADOWS[i].alpha   = _THUMBS[i].alpha / 2;
	        _SHADOWS[i].width   = _THUMBS[i].width;
            _SHADOWS[i].x       = _THUMBS[i].x;
            if(_SHADOWS[i].scaleY > 0) _SHADOWS[i].scaleY = -_SHADOWS[i].scaleY;
		   }
	     }
       }
      //title.text = new String(" p:"+position+" D:"+delta+" n:"+n+" o:"+offset);
	 }

    private function clickUp(event : MouseEvent) : void
     {
      if(scroll)
       {
        if(position > 0) { delta = scroll_speed; timer.start(); }
       }
      else
       {
        if(position > 0) position --;
        drawThumbs();
       }
     }

    private function clickDown(event : MouseEvent) : void
     {
	  if(scroll)
       {
	    if(position < _THUMBS.length - visible_thumbs) { delta = -scroll_speed; timer.start(); }
	   }
	  else
	   {
        if(position < _THUMBS.length - visible_thumbs) position ++;
        drawThumbs();
	   }
     }

    private function moveThumb(event : TimerEvent) : void
     {
	  var max : int;

	  if(layout) max = thumb_width + spacing; else max = thumb_height + spacing;
      offset += delta;
      if(delta < 0) if(offset < -max) { offset = 0; delta = 0; timer.stop(); position ++; }
      if(delta > 0) if(offset >  max) { offset = 0; delta = 0; timer.stop(); position --; }
      drawThumbs();
     }

    public function getThumb(i : int) : AR_Thumbnail
     {
	  return _THUMBS[i];
	 }

    public function getTotalThumbs() : int
     {
	  return _THUMBS.length;
	 }
   }
 }
